
#include <cmath>
#include <complex>
#include <algorithm>
#include <iostream>

#include "hark-lib/node/Iterate.h"

namespace hark
{
namespace node
{
    Iterate::Iterate():
        NodeDef("Iterate")
    {
        *this
            << Terminal::in("MAX_ITER").def(1)
            >> Terminal::out("OUTPUT");
    }

    void
    Iterate::reset()
    {
    }

    void
    Iterate::initialize(InputDataBundle &input)
    {
        this->max_iter = input["MAX_ITER"].last().as<int>();
    }

    bool
    Iterate::operator () (size_t count, InputDataBundle &input, OutputDataBundle &output)
    {
#ifdef DEBUG
        ptime start_time;
        ptime end_time;
        start_time = microsec_clock::local_time();
#endif

        if(count == 0){ this->initialize(input); }

        output["OUTPUT"].push(data::create<bool>((count < this->max_iter) ? true : false));

#ifdef DEBUG
        end_time = microsec_clock::local_time();
        std::cout << end_time - start_time << std::endl;
#endif

        return true;
    }
}
}

/* end of file */
